//https://www.youtube.com/BitaBit

//https://www.bitabittecnologia.com.br

//Exemplo Para controlar o cursor do display usando um joystick e inserir um número
//na posição atual do cursor, apertando o botão do joystick.

#include <LiquidCrystal.h>

int rs = 12; //Pino Register select
int e = 11;  //Pino Enable
int d4 = 5;  //Pino de dados d4
int d5 = 4;  //Pino de dados d5
int d6 = 3;  //Pino de dados d6 
int d7 = 2;  //Pino de dados d7

//Pinos usados pelo joystick.
int eixo_x = 0;
int eixo_y = 1;
int botao = 10;

int linha_atual = 0;
int coluna_atual = 0;

LiquidCrystal lcd(rs, e, d4, d5, d6, d7);

void setup() 
{
  lcd.begin(16, 2); //LCD de 16 colunas e 2 linhas.

  Serial.begin(9600);

  lcd.setCursor(0, 0);

  lcd.cursor(); //Faz o cursor aparecer, se usar noCursor() faz o cursor sumir.
  lcd.blink(); //Faz o cursor piscar, se usar noBlink() faz o cursor parar de piscar.

  Serial.begin(9600);

  pinMode(botao, INPUT_PULLUP);
}

void loop() 
{
  //Ao pressionar o botão, irá digitar um na posição atual do cursor.
  if(!digitalRead(botao))
  {
    lcd.print("1");

    //Necessário atualizar a posição do cursor, devido que quando o caractere é inserido
    //o cursor pula para a próxima coluna automaticamente.
    coluna_atual++;
  }

  //Move cursor para esquerda.
  if(analogRead(eixo_x) < 300)
  {
    if(coluna_atual >= 1)
    {
      lcd.setCursor(--coluna_atual, linha_atual);
    }
  }

  //Move cursor para a direita.
  if(analogRead(eixo_x) > 700)
  {
    if(coluna_atual <= 14)
    {
      lcd.setCursor(++coluna_atual, linha_atual);
    }
  }

  //Move cursor para cima.
  if(analogRead(eixo_y) < 300)
  {
    if(linha_atual >= 1)
    {
      lcd.setCursor(coluna_atual, --linha_atual);
    }
  }

  //Move cursor para baixo.
  if(analogRead(eixo_y) > 700)
  {
    if(linha_atual <= 0)
    {
      lcd.setCursor(coluna_atual, ++linha_atual);
    }
  }

  //Verificar os valores do joystick na serial para calibrar.
  Serial.print("Eixo X: ");
  Serial.println(analogRead(eixo_x));

  Serial.print("Eixo Y: ");
  Serial.println(analogRead(eixo_y));

  delay(200);
}